IF ISTABLE("Keyviol") THEN
 DELETE "Keyviol"
ENDIF
{Modify} {DataEntry} {Contacts}
WAIT TABLE
 PROMPT "Entering Records for Contacts table",
        "Press [F2] when finished, or [Esc] to abort"
 UNTIL "F2", "Esc"
SWITCH
 CASE retval = "F2":
  Do_It!
 CASE retval = "Esc":
  CANCELEDIT
 ENDSWITCH
ClearAll
WHILE ISTABLE("Keyviol")
 RENAME "Keyviol" "Entry"
 VIEW "Contacts"
 EDIT "Entry"
 waitmess = "These Entry records produce key violations in Contacts"
 WHILE True
  WAIT TABLE
   PROMPT "[F2] - Add records as new entries, [Alt][F2] Update old records",
          "[F3] - Move between Entry and Contacts, [Esc] - Cancel"
   MESSAGE waitmess
   UNTIL "F2", -105, "Esc", "F3"
   SWITCH
   CASE retval = "F2":
    Do_It!
    {Tools} {More} {Add} {Entry} {Contacts} {NewEntries}
    QUITLOOP
   CASE retval = -105:
    Do_It!
    ADD "Entry" "Contacts"
    QUITLOOP
   CASE retval = "Esc":
    CANCELEDIT
    QUITLOOP
   CASE retval = "F3":
    IF TABLE() = "Entry" THEN
     UpImage
     IMAGERIGHTS READONLY
     waitmess = "Viewing Contacts table"
    ELSE
     DownImage
     IMAGERIGHTS
     waitmess = "Editing Entry table"
    ENDIF
  ENDSWITCH
 ENDWHILE
 ClearAll
ENDWHILE
